<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kd7w2jm6rvvx6pnfgbmafdxkx875y5cf-vendored-sources/serde-1.0.140/src/private/mod.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>mod.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../serde/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../serde/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../serde/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
</pre><pre class="rust"><code><span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">no_serde_derive</span>))]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">de</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">no_serde_derive</span>))]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">ser</span>;

<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">size_hint</span>;

<span class="comment">// FIXME: #[cfg(doctest)] once https://github.com/rust-lang/rust/issues/67295 is fixed.</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">doc</span>;

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">lib::clone::Clone</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">lib::convert</span>::{<span class="ident">From</span>, <span class="ident">Into</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">lib::default::Default</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">lib::fmt</span>::{<span class="self">self</span>, <span class="ident">Formatter</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">lib::marker::PhantomData</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">lib::option::Option</span>::{<span class="self">self</span>, <span class="prelude-val">None</span>, <span class="prelude-val">Some</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">lib::ptr</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">lib::result::Result</span>::{<span class="self">self</span>, <span class="prelude-val">Err</span>, <span class="prelude-val">Ok</span>};

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::string::from_utf8_lossy</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>))]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">lib</span>::{<span class="ident">ToString</span>, <span class="ident">Vec</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">no_core_try_from</span>))]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">lib::convert::TryFrom</span>;

<span class="kw">mod</span> <span class="ident">string</span> {
    <span class="kw">use</span> <span class="ident">lib</span>::<span class="kw-2">*</span>;

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>))]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">from_utf8_lossy</span>(<span class="ident">bytes</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">Cow</span><span class="op">&lt;</span><span class="ident">str</span><span class="op">&gt;</span> {
        <span class="ident">String::from_utf8_lossy</span>(<span class="ident">bytes</span>)
    }

    <span class="comment">// The generated code calls this like:</span>
    <span class="comment">//</span>
    <span class="comment">//     let value = &amp;_serde::__private::from_utf8_lossy(bytes);</span>
    <span class="comment">//     Err(_serde::de::Error::unknown_variant(value, VARIANTS))</span>
    <span class="comment">//</span>
    <span class="comment">// so it is okay for the return type to be different from the std case as long</span>
    <span class="comment">// as the above works.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;alloc&quot;</span>)))]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">from_utf8_lossy</span>(<span class="ident">bytes</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="kw-2">&amp;</span><span class="ident">str</span> {
        <span class="comment">// Three unicode replacement characters if it fails. They look like a</span>
        <span class="comment">// white-on-black question mark. The user will recognize it as invalid</span>
        <span class="comment">// UTF-8.</span>
        <span class="ident">str::from_utf8</span>(<span class="ident">bytes</span>).<span class="ident">unwrap_or</span>(<span class="string">&quot;\u{fffd}\u{fffd}\u{fffd}&quot;</span>)
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="serde" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>